#FORMAT python
#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

"""
A jsMath formatter

Author: Thomas Themel <themel0r@wannabehacker.com>

"""

Dependencies = []

#<SCRIPT SRC="jsmath/jsMath.js"></SCRIPT>
#<SCRIPT SRC="http://sage.math.washington.edu/tmp/jsmath/jsMath.js"></SCRIPT>

jsmathinclude = '''
    <!-- <A HREF="http://www.math.union.edu/locate/jsMath">jsMath</A> -->
    <script>jsMath = {Controls: {cookie: {scale: 115}}}</script>
    <script src="/wiki/jsmath/plugins/noImageFonts.js"></script>
    <SCRIPT SRC="/wiki/jsmath/jsMath.js"></SCRIPT>
    <SCRIPT>
      addLoadEvent (function () {
        jsMath.Process();
      });
    </SCRIPT>
    '''


import sha, os, tempfile, shutil, re
from MoinMoin.Page import Page
from MoinMoin.parser import wiki

class Parser(wiki.Parser):
    extensions = ['*']

    scripts_loaded = None

    def __init__(self, raw, request, **kw):
        self.formatting_rules += r'|(?P<jsmath_formula>\$[^$].*?(?<!\\)\$)'
        self.formatting_rules += r'|(?P<jsmath_formula_para>\$\$.*?(?<!\\)\$\$)'
        wiki.Parser.__init__(self, raw, request, **kw)
        self.raw = raw
        self.request = request
        self.exclude = []

    def script_header(self):
        if self.scripts_loaded is None:
            return jsmathinclude
            self.scripts_loaded = 1 
        else:
            return ''

    def format(self, formatter):
    	self.request.write(self.script_header())
    	wiki.Parser.format(self, formatter)

            
    def _jsmath_formula_repl(self, text, **kw):
        return '<span class="math">'  + text[1:-1] + '</span>'

    def _jsmath_formula_para_repl(self, text, **kw):
        return '<div class="math">'  + text[2:-2] + '</div>'

